<template>
  <b-field
    :type="{ 'is-danger': $v.email.$error }"
    :message="{
      'Email is required': $v.email.$error && !$v.email.required,
      'Email is not in correct format': $v.email.$error && !$v.email.email
    }"
    label="Email">
    <b-input
      v-model="$v.email.$model"
      size="is-medium"
    />
  </b-field>
</template>

<script>
import { requiredIf, email } from 'vuelidate/lib/validators'

export default {
  props: {
    value: {
      type: String,
      default: ''
    },
    required: {
      type: Boolean,
      default: false
    }
  },
  validations: {
    email: { required: requiredIf('isRequired'), email }
  },
  computed: {
    email: {
      get () {
        return this.value
      },

      set (value) {
        this.$emit('input', value)
      }
    },
    isRequired () {
      return this.required
    }
  }
}
</script>
